(********************************************************************
 * COPYRIGHT -- halstrup-walcher GmbH
 ********************************************************************
 * Program: ExamplePrg
 * File: ExamplePrg.st
 * Author: herbigs
 * Created: January 21, 2016
 ********************************************************************
 * Implementation of program ExamplePrg
 ********************************************************************)

PROGRAM _INIT
	// Motor 1
	Motor_1.NodeID := 1;
	Motor_1.Device := 'IF3';
	hwMC_Move_1.pDrive := ADR(Motor_1);
	hwMC_Error_1.pDrive := ADR(Motor_1);
	hwMC_ReadParameter_1.pDrive := ADR(Motor_1);
	hwMC_Parametrization_1.pDrive := ADR(Motor_1);
	hwMC_PositionParametrization_1.pDrive := ADR(Motor_1);
	// Motor 2
	Motor_2.NodeID := 2;
	Motor_2.Device := 'IF3';
	hwMC_Move_2.pDrive := ADR(Motor_2);
	hwMC_Error_2.pDrive := ADR(Motor_2);
	hwMC_ReadParameter_2.pDrive := ADR(Motor_2);
	hwMC_Parametrization_2.pDrive := ADR(Motor_2);
	hwMC_PositionParametrization_2.pDrive := ADR(Motor_2);
END_PROGRAM

PROGRAM _CYCLIC
	// Motor 1
	hwMC_Move_1.Release := Motor_1_Release;
	hwMC_Move_1.ManualRunToLargerValues := Motor_1_ManualRunToLargerValues;
	hwMC_Move_1.ManualRunToSmallerValues := Motor_1_ManualRunToSmallerValues;
	hwMC_Move_1.Position := Motor_1_Position;
	hwMC_Move_1;
	hwMC_Error_1;
	IF hwMC_ReadParameter_1.Done THEN
		hwMC_ReadParameter_1.Execute := FALSE;
	ELSE
		IF Motor_1_Read = 0 THEN
			IF NOT hwMC_ReadParameter_1.Execute THEN
				NumberOfCycles_lastRead_Motor_1 := NumberOfCycles_ReadPar_Motor_1;
				NumberOfCycles_ReadPar_Motor_1 := 0;
			END_IF
			hwMC_ReadParameter_1.Execute := TRUE; // if continuous test is active --> read parameters only each 10th time
		END_IF
		IF hwMC_ReadParameter_1.Execute THEN
			NumberOfCycles_ReadPar_Motor_1 := NumberOfCycles_ReadPar_Motor_1 + 1;
		END_IF
	END_IF
	hwMC_ReadParameter_1; // cyclically read the same parameters (Activate the desired parameters in the Watch window!)
	hwMC_Parametrization_1;
	hwMC_PositionParametrization_1;
	// Motor 2
	hwMC_Move_2.Release := Motor_2_Release;
	hwMC_Move_2.ManualRunToLargerValues := Motor_2_ManualRunToLargerValues;
	hwMC_Move_2.ManualRunToSmallerValues := Motor_2_ManualRunToSmallerValues;
	hwMC_Move_2.Position := Motor_2_Position;
	hwMC_Move_2;
	hwMC_Error_2;
	IF hwMC_ReadParameter_2.Done THEN
		hwMC_ReadParameter_2.Execute := FALSE;
	ELSE
		IF Motor_2_Read = 0 THEN
			IF NOT hwMC_ReadParameter_2.Execute THEN
				NumberOfCycles_lastRead_Motor_2 := NumberOfCycles_ReadPar_Motor_2;
				NumberOfCycles_ReadPar_Motor_2 := 0;
			END_IF
			hwMC_ReadParameter_2.Execute := TRUE; // if continuous test is active --> read parameters only each 10th time
		END_IF
		IF hwMC_ReadParameter_2.Execute THEN
			NumberOfCycles_ReadPar_Motor_2 := NumberOfCycles_ReadPar_Motor_2 + 1;
		END_IF
	END_IF
	hwMC_ReadParameter_2; // cyclically read the same parameters (Activate the desired parameters in the Watch window!)
	hwMC_Parametrization_2;
	hwMC_PositionParametrization_2;
	// Sequence Control
	IF ContinuousTest THEN
		IF NOT hwMC_Move_1.Active AND NOT hwMC_Move_2.Active THEN
			Motor_1_Release := TRUE;
			Motor_2_Release := TRUE;
			IF Motor_1_active THEN
				// Recently motor 1 was active --> Move motor 2 to the same position.
				Motor_1_active := FALSE;
				Motor_2_Position := Motor_1_Position;
			ELSE
				// Recently motor 2 was active --> Move motor 1 to the next position.
				Motor_1_active := TRUE;
				IF Motor_1_backward THEN
					IF Motor_1_Position >= 1550 THEN
						Motor_1_Position := Motor_1_Position - 100;
					ELSE
						Motor_1_backward := FALSE;
						Motor_1_Position := 1450;
					END_IF
				ELSE
					IF Motor_1_Position <= 100200 THEN
						Motor_1_Position := Motor_1_Position + 100;
					ELSE
						Motor_1_backward := TRUE;
						Motor_1_Position := 101200;
					END_IF
				END_IF
			END_IF
		END_IF
		IF Motor_1_Read = 0 THEN
			Motor_1_Read := 10;
		ELSE
			Motor_1_Read := Motor_1_Read - 1;
		END_IF
		IF Motor_2_Read = 0 THEN
			Motor_2_Read := 10;
		ELSE
			Motor_2_Read := Motor_2_Read - 1;
		END_IF
	ELSE
		Motor_1_Read := 0;
		Motor_2_Read := 0;
		Motor_1_Position := 51200;
		Motor_2_Position := 51200;
	END_IF
END_PROGRAM
