/* Durch Automation Studio generierte Headerdatei*/
/* Nicht bearbeiten! */

#ifndef _H_W_
#define _H_W_
#ifdef __cplusplus
extern "C" 
{
#endif

#include <bur/plctypes.h>

#ifndef _BUR_PUBLIC
#define _BUR_PUBLIC
#endif
#ifdef _SG4
		#include "AsEPL.h"
#endif

#ifdef _SG3
		#include "AsEPL.h"
#endif

#ifdef _SGC
		#include "AsEPL.h"
#endif

/* Datentypen und Datentypen von Funktionsblcken */
typedef struct PSxOut_type
{	unsigned short ControlWord;
	signed long TargetPosition;
} PSxOut_type;

typedef struct PSxIn_type
{	plcbit ModuleOK;
	unsigned short StatusWord;
	signed long ActualPosition;
	signed short ActualSpeed;
} PSxIn_type;

typedef struct PSx_type
{	unsigned char NodeID;
	plcstring Device[31];
	struct PSxIn_type In;
	struct PSxOut_type Out;
	unsigned char State;
} PSx_type;

typedef struct hwMC_Move
{
	/* VAR_INPUT (analog) */
	unsigned long pDrive;
	signed long Position;
	/* VAR_OUTPUT (analog) */
	signed long ActualPosition;
	unsigned short ErrorID;
	/* VAR (analog) */
	struct PSx_type* Drive;
	signed long Position_Old;
	struct EplSDORead EplSDORead_0;
	unsigned short StatusWord;
	/* VAR_INPUT (digital) */
	plcbit Release;
	plcbit ManualRunToLargerValues;
	plcbit ManualRunToSmallerValues;
	/* VAR_OUTPUT (digital) */
	plcbit Active;
	plcbit InPosition;
	plcbit Error;
	/* VAR (digital) */
	plcbit ModuleOK_Old;
	plcbit Release_Old;
	plcbit StartingPhase;
	plcbit sendSDO;
} hwMC_Move_typ;

typedef struct hwMC_Error
{
	/* VAR_INPUT (analog) */
	unsigned long pDrive;
	/* VAR_OUTPUT (analog) */
	unsigned short ErrorID;
	plcstring ErrorDescription[81];
	/* VAR (analog) */
	struct PSx_type* Drive;
	/* VAR_INPUT (digital) */
	plcbit Enable;
	/* VAR_OUTPUT (digital) */
	plcbit Error;
} hwMC_Error_typ;

typedef struct hwMC_ReadParameter
{
	/* VAR_INPUT (analog) */
	unsigned long pDrive;
	/* VAR_OUTPUT (analog) */
	unsigned short ErrorID;
	unsigned short ErrorParameter;
	unsigned short StatusWord_Value;
	signed short ActualSpeed_Value;
	signed long ActualPosition_Value;
	unsigned short ActualTorque_Value;
	unsigned short MaxTorqueLastRun_Value;
	unsigned short U_Control_Value;
	unsigned short U_Motor_Value;
	unsigned short DeviceTemperature_Value;
	unsigned short ProductionDate_Value;
	unsigned short SerialNumber_Value;
	plcstring DeviceVariant_Value[32];
	unsigned short SoftwareVersion_Value;
	unsigned short ControlWord_Value;
	signed long TargetPosition_Value;
	unsigned short DirRotation_Value;
	unsigned short PosScaleNumerator_Value;
	unsigned short PosScaleDenominator_Value;
	signed long ReferencingValue_Value;
	signed long UpperMappingEnd_Value;
	signed long UpperLimit_Value;
	signed long LowerLimit_Value;
	unsigned short PositionWindow_Value;
	signed long LoopLength_Value;
	unsigned short DragError_Value;
	unsigned char Readjustment_Value;
	unsigned short DragErrorCorrection_Value;
	unsigned short TargetSpeed_Value;
	unsigned short TargetSpeedManual_Value;
	unsigned short SpeedLimitAbort_Value;
	unsigned short Acceleration_Value;
	unsigned short Deceleration_Value;
	unsigned short MaxStartTorque_Value;
	unsigned short MaxTorque_Value;
	unsigned short MaxHoldTorqueEndRun_Value;
	unsigned short MaxHoldTorque_Value;
	unsigned short AbortRunTime_Value;
	unsigned short StartTorqueTime_Value;
	unsigned short MaxHoldTorqueEndRunTime_Value;
	unsigned short DirectionChangeTime_Value;
	unsigned short BreakReleaseTimeEndRun_Value;
	unsigned short MotVoltageFilterTime_Value;
	unsigned long GeneralPurpose_1_Value;
	unsigned long GeneralPurpose_2_Value;
	unsigned long GeneralPurpose_3_Value;
	unsigned long GeneralPurpose_4_Value;
	unsigned long GeneralPurpose_5_Value;
	unsigned long GeneralPurpose_6_Value;
	unsigned long GeneralPurpose_7_Value;
	unsigned long GeneralPurpose_8_Value;
	unsigned long GeneralPurpose_9_Value;
	unsigned long GeneralPurpose_10_Value;
	unsigned short MinVoltage_Value;
	unsigned short MaxTemperature_Value;
	unsigned short Address_Value;
	unsigned short ConfigConnectionTimeout_Value;
	signed long SafePositionConnTimeout_Value;
	signed long RepetitionTimeSafePosRun_Value;
	signed short DeliveryState_Value;
	/* VAR (analog) */
	struct PSx_type* Drive;
	struct EplSDORead EplSDORead_0;
	unsigned short state;
	/* VAR_INPUT (digital) */
	plcbit Execute;
	plcbit StatusWord_Enable;
	plcbit ActualSpeed_Enable;
	plcbit ActualPosition_Enable;
	plcbit ActualTorque_Enable;
	plcbit MaxTorqueLastRun_Enable;
	plcbit U_Control_Enable;
	plcbit U_Motor_Enable;
	plcbit DeviceTemperature_Enable;
	plcbit ProductionDate_Enable;
	plcbit SerialNumber_Enable;
	plcbit DeviceVariant_Enable;
	plcbit SoftwareVersion_Enable;
	plcbit ControlWord_Enable;
	plcbit TargetPosition_Enable;
	plcbit DirRotation_Enable;
	plcbit PosScaleNumerator_Enable;
	plcbit PosScaleDenominator_Enable;
	plcbit ReferencingValue_Enable;
	plcbit UpperMappingEnd_Enable;
	plcbit UpperLimit_Enable;
	plcbit LowerLimit_Enable;
	plcbit PositionWindow_Enable;
	plcbit LoopLength_Enable;
	plcbit DragError_Enable;
	plcbit Readjustment_Enable;
	plcbit DragErrorCorrection_Enable;
	plcbit TargetSpeed_Enable;
	plcbit TargetSpeedManual_Enable;
	plcbit SpeedLimitAbort_Enable;
	plcbit Acceleration_Enable;
	plcbit Deceleration_Enable;
	plcbit MaxStartTorque_Enable;
	plcbit MaxTorque_Enable;
	plcbit MaxHoldTorqueEndRun_Enable;
	plcbit MaxHoldTorque_Enable;
	plcbit AbortRunTime_Enable;
	plcbit StartTorqueTime_Enable;
	plcbit MaxHoldTorqueEndRunTime_Enable;
	plcbit DirectionChangeTime_Enable;
	plcbit BreakReleaseTimeEndRun_Enable;
	plcbit MotVoltageFilterTime_Enable;
	plcbit GeneralPurpose_1_Enable;
	plcbit GeneralPurpose_2_Enable;
	plcbit GeneralPurpose_3_Enable;
	plcbit GeneralPurpose_4_Enable;
	plcbit GeneralPurpose_5_Enable;
	plcbit GeneralPurpose_6_Enable;
	plcbit GeneralPurpose_7_Enable;
	plcbit GeneralPurpose_8_Enable;
	plcbit GeneralPurpose_9_Enable;
	plcbit GeneralPurpose_10_Enable;
	plcbit MinVoltage_Enable;
	plcbit MaxTemperature_Enable;
	plcbit Address_Enable;
	plcbit ConfigConnectionTimeout_Enable;
	plcbit SafePositionConnTimeout_Enable;
	plcbit RepetitionTimeSafePosRun_Enable;
	plcbit DeliveryState_Enable;
	/* VAR_OUTPUT (digital) */
	plcbit Active;
	plcbit Done;
	plcbit Error;
} hwMC_ReadParameter_typ;

typedef struct hwMC_Parametrization
{
	/* VAR_INPUT (analog) */
	unsigned long pDrive;
	unsigned short DirRotation_Value;
	unsigned short PosScaleNumerator_Value;
	unsigned short PosScaleDenominator_Value;
	signed long ActualPosition_Value;
	signed long ReferencingValue_Value;
	signed long UpperMappingEnd_Value;
	signed long UpperLimit_Value;
	signed long LowerLimit_Value;
	unsigned short PositionWindow_Value;
	signed long LoopLength_Value;
	unsigned short DragError_Value;
	unsigned char Readjustment_Value;
	unsigned short DragErrorCorrection_Value;
	unsigned short TargetSpeed_Value;
	unsigned short TargetSpeedManual_Value;
	unsigned short SpeedLimitAbort_Value;
	unsigned short Acceleration_Value;
	unsigned short Deceleration_Value;
	unsigned short MaxStartTorque_Value;
	unsigned short MaxTorque_Value;
	unsigned short MaxHoldTorqueEndRun_Value;
	unsigned short MaxHoldTorque_Value;
	unsigned short AbortRunTime_Value;
	unsigned short StartTorqueTime_Value;
	unsigned short MaxHoldTorqueEndRunTime_Value;
	unsigned short DirectionChangeTime_Value;
	unsigned short BreakReleaseTimeEndRun_Value;
	unsigned short MotVoltageFilterTime_Value;
	unsigned long GeneralPurpose_1_Value;
	unsigned long GeneralPurpose_2_Value;
	unsigned long GeneralPurpose_3_Value;
	unsigned long GeneralPurpose_4_Value;
	unsigned long GeneralPurpose_5_Value;
	unsigned long GeneralPurpose_6_Value;
	unsigned long GeneralPurpose_7_Value;
	unsigned long GeneralPurpose_8_Value;
	unsigned long GeneralPurpose_9_Value;
	unsigned long GeneralPurpose_10_Value;
	unsigned short MinVoltage_Value;
	unsigned short MaxTemperature_Value;
	unsigned short Address_Value;
	unsigned short ConfigConnectionTimeout_Value;
	signed long SafePositionConnTimeout_Value;
	signed long RepetitionTimeSafePosRun_Value;
	/* VAR_OUTPUT (analog) */
	unsigned short ErrorID;
	unsigned short ErrorParameter;
	/* VAR (analog) */
	struct PSx_type* Drive;
	struct EplSDOWrite EplSDOWrite_0;
	signed long Value;
	unsigned short state;
	/* VAR_INPUT (digital) */
	plcbit Execute;
	plcbit DeliveryState;
	plcbit DirRotation_Enable;
	plcbit PosScaleNumerator_Enable;
	plcbit PosScaleDenominator_Enable;
	plcbit ActualPosition_Enable;
	plcbit ReferencingValue_Enable;
	plcbit UpperMappingEnd_Enable;
	plcbit UpperLimit_Enable;
	plcbit LowerLimit_Enable;
	plcbit PositionWindow_Enable;
	plcbit LoopLength_Enable;
	plcbit DragError_Enable;
	plcbit Readjustment_Enable;
	plcbit DragErrorCorrection_Enable;
	plcbit TargetSpeed_Enable;
	plcbit TargetSpeedManual_Enable;
	plcbit SpeedLimitAbort_Enable;
	plcbit Acceleration_Enable;
	plcbit Deceleration_Enable;
	plcbit MaxStartTorque_Enable;
	plcbit MaxTorque_Enable;
	plcbit MaxHoldTorqueEndRun_Enable;
	plcbit MaxHoldTorque_Enable;
	plcbit AbortRunTime_Enable;
	plcbit StartTorqueTime_Enable;
	plcbit MaxHoldTorqueEndRunTime_Enable;
	plcbit DirectionChangeTime_Enable;
	plcbit BreakReleaseTimeEndRun_Enable;
	plcbit MotVoltageFilterTime_Enable;
	plcbit GeneralPurpose_1_Enable;
	plcbit GeneralPurpose_2_Enable;
	plcbit GeneralPurpose_3_Enable;
	plcbit GeneralPurpose_4_Enable;
	plcbit GeneralPurpose_5_Enable;
	plcbit GeneralPurpose_6_Enable;
	plcbit GeneralPurpose_7_Enable;
	plcbit GeneralPurpose_8_Enable;
	plcbit GeneralPurpose_9_Enable;
	plcbit GeneralPurpose_10_Enable;
	plcbit MinVoltage_Enable;
	plcbit MaxTemperature_Enable;
	plcbit Address_Enable;
	plcbit ConfigConnectionTimeout_Enable;
	plcbit SafePositionConnTimeout_Enable;
	plcbit RepetitionTimeSafePosRun_Enable;
	plcbit SaveSettings;
	/* VAR_OUTPUT (digital) */
	plcbit Active;
	plcbit Done;
	plcbit Error;
} hwMC_Parametrization_typ;

typedef struct hwMC_PositionParametrization
{
	/* VAR_INPUT (analog) */
	unsigned long pDrive;
	unsigned short Direction;
	unsigned short StepsPerTurn;
	signed long LowerLimit;
	signed long UpperLimit;
	signed long SetPoint;
	/* VAR_OUTPUT (analog) */
	unsigned short ErrorID;
	unsigned short ErrorParameter;
	/* VAR (analog) */
	struct PSx_type* Drive;
	struct EplSDOWrite EplSDOWrite_0;
	signed long Value;
	unsigned short state;
	/* VAR_INPUT (digital) */
	plcbit Execute;
	plcbit SaveSettings;
	/* VAR_OUTPUT (digital) */
	plcbit Active;
	plcbit Done;
	plcbit Error;
} hwMC_PositionParametrization_typ;



/* Prototyping of functions and function blocks */
_BUR_PUBLIC void hwMC_Move(struct hwMC_Move* inst);
_BUR_PUBLIC void hwMC_Error(struct hwMC_Error* inst);
_BUR_PUBLIC void hwMC_ReadParameter(struct hwMC_ReadParameter* inst);
_BUR_PUBLIC void hwMC_Parametrization(struct hwMC_Parametrization* inst);
_BUR_PUBLIC void hwMC_PositionParametrization(struct hwMC_PositionParametrization* inst);


#ifdef __cplusplus
};
#endif
#endif /* _H_W_ */

